/*
     Copyright (C) 2004, 2020 Hubert Vansteenhuyse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "subnet.h"
extern int left(int y, char *str);
extern char *format(char *fmt, ...);

char win_kbd = 0;

char getinput(void){
    int ch = 0;
#ifdef __LINUX__
    ch = getch();

    if (!isprint(ch) && (ch & KEY_CODE_YES)) {

        //left(0, format("KEYCODE: 0x%X   ", ch));
        if (ch == KEY_PPAGE)
            return PGU;
        if (ch == KEY_NPAGE)
            return PGD;
        if (ch == KEY_UP)
            return KEYU;
        if (ch == KEY_DOWN)
            return KEYD;
        if (ch == KEY_LEFT)
            return KEYL;
        if (ch == KEY_RIGHT)
            return KEYR;
        if (ch == KEY_BACKSPACE || ch == KEY_DC)
            return KEYBACK;
        return NOKEY;
    }
    if (ch == KEY_PPAGE)
        return PGU;
#endif				/*#__LINUX__ */

#ifdef __WINDOWS__
    MSG msg;
    win_kbd = 0;
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
        if (win_kbd)
            return win_kbd;
    }
#endif				/*#__WINDOWS__ */
    return (char) ch;
}
